package com.hfkj.dao;

import com.hfkj.entity.BsAgentApiAccount;
import com.hfkj.entity.BsAgentApiAccountExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsAgentApiAccountMapper extends BsAgentApiAccountMapperExt {
    @SelectProvider(type=BsAgentApiAccountSqlProvider.class, method="countByExample")
    long countByExample(BsAgentApiAccountExample example);

    @DeleteProvider(type=BsAgentApiAccountSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsAgentApiAccountExample example);

    @Delete({
        "delete from bs_agent_api_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_agent_api_account (agent_id, amount, ",
        "amount_consume, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{agentId,jdbcType=BIGINT}, #{amount,jdbcType=DECIMAL}, ",
        "#{amountConsume,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsAgentApiAccount record);

    @InsertProvider(type=BsAgentApiAccountSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsAgentApiAccount record);

    @SelectProvider(type=BsAgentApiAccountSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="amount_consume", property="amountConsume", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsAgentApiAccount> selectByExample(BsAgentApiAccountExample example);

    @Select({
        "select",
        "id, agent_id, amount, amount_consume, `status`, create_time, update_time, ext_1, ",
        "ext_2, ext_3",
        "from bs_agent_api_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="amount_consume", property="amountConsume", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsAgentApiAccount selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsAgentApiAccountSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsAgentApiAccount record, @Param("example") BsAgentApiAccountExample example);

    @UpdateProvider(type=BsAgentApiAccountSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsAgentApiAccount record, @Param("example") BsAgentApiAccountExample example);

    @UpdateProvider(type=BsAgentApiAccountSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsAgentApiAccount record);

    @Update({
        "update bs_agent_api_account",
        "set agent_id = #{agentId,jdbcType=BIGINT},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "amount_consume = #{amountConsume,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsAgentApiAccount record);
}