package com.hfkj.dao;

import com.hfkj.entity.BsDiscountPkStockBatch;
import com.hfkj.entity.BsDiscountPkStockBatchExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDiscountPkStockBatchMapper extends BsDiscountPkStockBatchMapperExt {
    @SelectProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="countByExample")
    long countByExample(BsDiscountPkStockBatchExample example);

    @DeleteProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDiscountPkStockBatchExample example);

    @Delete({
        "delete from bs_discount_pk_stock_batch",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_discount_pk_stock_batch (discount_pk_id, discount_pk_no, ",
        "discount_pk_name, batch_no, ",
        "batch_stock_num, start_id, ",
        "end_id, `status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{discountPkId,jdbcType=BIGINT}, #{discountPkNo,jdbcType=VARCHAR}, ",
        "#{discountPkName,jdbcType=VARCHAR}, #{batchNo,jdbcType=VARCHAR}, ",
        "#{batchStockNum,jdbcType=INTEGER}, #{startId,jdbcType=VARCHAR}, ",
        "#{endId,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDiscountPkStockBatch record);

    @InsertProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDiscountPkStockBatch record);

    @SelectProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_id", property="discountPkId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_name", property="discountPkName", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_no", property="batchNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_stock_num", property="batchStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="start_id", property="startId", jdbcType=JdbcType.VARCHAR),
        @Result(column="end_id", property="endId", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDiscountPkStockBatch> selectByExample(BsDiscountPkStockBatchExample example);

    @Select({
        "select",
        "id, discount_pk_id, discount_pk_no, discount_pk_name, batch_no, batch_stock_num, ",
        "start_id, end_id, `status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_discount_pk_stock_batch",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_id", property="discountPkId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_name", property="discountPkName", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_no", property="batchNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_stock_num", property="batchStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="start_id", property="startId", jdbcType=JdbcType.VARCHAR),
        @Result(column="end_id", property="endId", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDiscountPkStockBatch selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDiscountPkStockBatch record, @Param("example") BsDiscountPkStockBatchExample example);

    @UpdateProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDiscountPkStockBatch record, @Param("example") BsDiscountPkStockBatchExample example);

    @UpdateProvider(type=BsDiscountPkStockBatchSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDiscountPkStockBatch record);

    @Update({
        "update bs_discount_pk_stock_batch",
        "set discount_pk_id = #{discountPkId,jdbcType=BIGINT},",
          "discount_pk_no = #{discountPkNo,jdbcType=VARCHAR},",
          "discount_pk_name = #{discountPkName,jdbcType=VARCHAR},",
          "batch_no = #{batchNo,jdbcType=VARCHAR},",
          "batch_stock_num = #{batchStockNum,jdbcType=INTEGER},",
          "start_id = #{startId,jdbcType=VARCHAR},",
          "end_id = #{endId,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDiscountPkStockBatch record);
}