package com.hfkj.dao;

import com.hfkj.entity.BsDiscountPkStockCode;
import com.hfkj.entity.BsDiscountPkStockCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDiscountPkStockCodeMapper extends BsDiscountPkStockCodeMapperExt {
    @SelectProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="countByExample")
    long countByExample(BsDiscountPkStockCodeExample example);

    @DeleteProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDiscountPkStockCodeExample example);

    @Delete({
        "delete from bs_discount_pk_stock_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_discount_pk_stock_code (discount_pk_stock_batch_id, discount_pk_stock_batch_no, ",
        "discount_pk_id, discount_pk_no, ",
        "discount_pk_name, obtain_type, ",
        "obtain_time, receive_mer_user_id, ",
        "receive_mer_user_phone, `status`, ",
        "agent_appid, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{discountPkStockBatchId,jdbcType=BIGINT}, #{discountPkStockBatchNo,jdbcType=VARCHAR}, ",
        "#{discountPkId,jdbcType=BIGINT}, #{discountPkNo,jdbcType=VARCHAR}, ",
        "#{discountPkName,jdbcType=VARCHAR}, #{obtainType,jdbcType=INTEGER}, ",
        "#{obtainTime,jdbcType=TIMESTAMP}, #{receiveMerUserId,jdbcType=BIGINT}, ",
        "#{receiveMerUserPhone,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{agentAppid,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDiscountPkStockCode record);

    @InsertProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDiscountPkStockCode record);

    @SelectProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_stock_batch_id", property="discountPkStockBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_stock_batch_no", property="discountPkStockBatchNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_id", property="discountPkId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_name", property="discountPkName", jdbcType=JdbcType.VARCHAR),
        @Result(column="obtain_type", property="obtainType", jdbcType=JdbcType.INTEGER),
        @Result(column="obtain_time", property="obtainTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="receive_mer_user_id", property="receiveMerUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="receive_mer_user_phone", property="receiveMerUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_appid", property="agentAppid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDiscountPkStockCode> selectByExample(BsDiscountPkStockCodeExample example);

    @Select({
        "select",
        "id, discount_pk_stock_batch_id, discount_pk_stock_batch_no, discount_pk_id, ",
        "discount_pk_no, discount_pk_name, obtain_type, obtain_time, receive_mer_user_id, ",
        "receive_mer_user_phone, `status`, agent_appid, create_time, update_time, ext_1, ",
        "ext_2, ext_3",
        "from bs_discount_pk_stock_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_stock_batch_id", property="discountPkStockBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_stock_batch_no", property="discountPkStockBatchNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_id", property="discountPkId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_pk_name", property="discountPkName", jdbcType=JdbcType.VARCHAR),
        @Result(column="obtain_type", property="obtainType", jdbcType=JdbcType.INTEGER),
        @Result(column="obtain_time", property="obtainTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="receive_mer_user_id", property="receiveMerUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="receive_mer_user_phone", property="receiveMerUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_appid", property="agentAppid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDiscountPkStockCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDiscountPkStockCode record, @Param("example") BsDiscountPkStockCodeExample example);

    @UpdateProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDiscountPkStockCode record, @Param("example") BsDiscountPkStockCodeExample example);

    @UpdateProvider(type=BsDiscountPkStockCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDiscountPkStockCode record);

    @Update({
        "update bs_discount_pk_stock_code",
        "set discount_pk_stock_batch_id = #{discountPkStockBatchId,jdbcType=BIGINT},",
          "discount_pk_stock_batch_no = #{discountPkStockBatchNo,jdbcType=VARCHAR},",
          "discount_pk_id = #{discountPkId,jdbcType=BIGINT},",
          "discount_pk_no = #{discountPkNo,jdbcType=VARCHAR},",
          "discount_pk_name = #{discountPkName,jdbcType=VARCHAR},",
          "obtain_type = #{obtainType,jdbcType=INTEGER},",
          "obtain_time = #{obtainTime,jdbcType=TIMESTAMP},",
          "receive_mer_user_id = #{receiveMerUserId,jdbcType=BIGINT},",
          "receive_mer_user_phone = #{receiveMerUserPhone,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "agent_appid = #{agentAppid,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDiscountPkStockCode record);
}