package com.hfkj.dao;

import com.hfkj.entity.BsDiscountUseMer;
import com.hfkj.entity.BsDiscountUseMerExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDiscountUseMerMapper extends BsDiscountUseMerMapperExt {
    @SelectProvider(type=BsDiscountUseMerSqlProvider.class, method="countByExample")
    long countByExample(BsDiscountUseMerExample example);

    @DeleteProvider(type=BsDiscountUseMerSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDiscountUseMerExample example);

    @Delete({
        "delete from bs_discount_use_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_discount_use_mer (discount_id, discount_no, ",
        "province_code, province_name, ",
        "city_code, city_name, ",
        "area_code, area_name, ",
        "mer_id, mer_no, mer_name, ",
        "mer_address, create_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountId,jdbcType=BIGINT}, #{discountNo,jdbcType=VARCHAR}, ",
        "#{provinceCode,jdbcType=BIGINT}, #{provinceName,jdbcType=VARCHAR}, ",
        "#{cityCode,jdbcType=BIGINT}, #{cityName,jdbcType=VARCHAR}, ",
        "#{areaCode,jdbcType=BIGINT}, #{areaName,jdbcType=VARCHAR}, ",
        "#{merId,jdbcType=BIGINT}, #{merNo,jdbcType=VARCHAR}, #{merName,jdbcType=VARCHAR}, ",
        "#{merAddress,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDiscountUseMer record);

    @InsertProvider(type=BsDiscountUseMerSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDiscountUseMer record);

    @SelectProvider(type=BsDiscountUseMerSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_code", property="provinceCode", jdbcType=JdbcType.BIGINT),
        @Result(column="province_name", property="provinceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_code", property="cityCode", jdbcType=JdbcType.BIGINT),
        @Result(column="city_name", property="cityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="area_code", property="areaCode", jdbcType=JdbcType.BIGINT),
        @Result(column="area_name", property="areaName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_address", property="merAddress", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDiscountUseMer> selectByExample(BsDiscountUseMerExample example);

    @Select({
        "select",
        "id, discount_id, discount_no, province_code, province_name, city_code, city_name, ",
        "area_code, area_name, mer_id, mer_no, mer_name, mer_address, create_time, ext_1, ",
        "ext_2, ext_3",
        "from bs_discount_use_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_code", property="provinceCode", jdbcType=JdbcType.BIGINT),
        @Result(column="province_name", property="provinceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_code", property="cityCode", jdbcType=JdbcType.BIGINT),
        @Result(column="city_name", property="cityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="area_code", property="areaCode", jdbcType=JdbcType.BIGINT),
        @Result(column="area_name", property="areaName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_address", property="merAddress", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDiscountUseMer selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDiscountUseMerSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDiscountUseMer record, @Param("example") BsDiscountUseMerExample example);

    @UpdateProvider(type=BsDiscountUseMerSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDiscountUseMer record, @Param("example") BsDiscountUseMerExample example);

    @UpdateProvider(type=BsDiscountUseMerSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDiscountUseMer record);

    @Update({
        "update bs_discount_use_mer",
        "set discount_id = #{discountId,jdbcType=BIGINT},",
          "discount_no = #{discountNo,jdbcType=VARCHAR},",
          "province_code = #{provinceCode,jdbcType=BIGINT},",
          "province_name = #{provinceName,jdbcType=VARCHAR},",
          "city_code = #{cityCode,jdbcType=BIGINT},",
          "city_name = #{cityName,jdbcType=VARCHAR},",
          "area_code = #{areaCode,jdbcType=BIGINT},",
          "area_name = #{areaName,jdbcType=VARCHAR},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "mer_address = #{merAddress,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDiscountUseMer record);
}