package com.hfkj.dao;

import com.hfkj.entity.BsGasOilPriceWeek;
import com.hfkj.entity.BsGasOilPriceWeekExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsGasOilPriceWeekMapper extends BsGasOilPriceWeekMapperExt {
    @SelectProvider(type=BsGasOilPriceWeekSqlProvider.class, method="countByExample")
    long countByExample(BsGasOilPriceWeekExample example);

    @DeleteProvider(type=BsGasOilPriceWeekSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsGasOilPriceWeekExample example);

    @Delete({
        "delete from bs_gas_oil_price_week",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_gas_oil_price_week (mer_id, mer_no, ",
        "weeks, oil_type, ",
        "oil_type_name, oil_no, ",
        "oil_no_name, price_official, ",
        "price_gun, price_vip, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merId,jdbcType=BIGINT}, #{merNo,jdbcType=VARCHAR}, ",
        "#{weeks,jdbcType=INTEGER}, #{oilType,jdbcType=INTEGER}, ",
        "#{oilTypeName,jdbcType=VARCHAR}, #{oilNo,jdbcType=VARCHAR}, ",
        "#{oilNoName,jdbcType=VARCHAR}, #{priceOfficial,jdbcType=DECIMAL}, ",
        "#{priceGun,jdbcType=DECIMAL}, #{priceVip,jdbcType=DECIMAL}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsGasOilPriceWeek record);

    @InsertProvider(type=BsGasOilPriceWeekSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsGasOilPriceWeek record);

    @SelectProvider(type=BsGasOilPriceWeekSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="weeks", property="weeks", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type_name", property="oilTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no_name", property="oilNoName", jdbcType=JdbcType.VARCHAR),
        @Result(column="price_official", property="priceOfficial", jdbcType=JdbcType.DECIMAL),
        @Result(column="price_gun", property="priceGun", jdbcType=JdbcType.DECIMAL),
        @Result(column="price_vip", property="priceVip", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsGasOilPriceWeek> selectByExample(BsGasOilPriceWeekExample example);

    @Select({
        "select",
        "id, mer_id, mer_no, weeks, oil_type, oil_type_name, oil_no, oil_no_name, price_official, ",
        "price_gun, price_vip, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_gas_oil_price_week",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="weeks", property="weeks", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type_name", property="oilTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no_name", property="oilNoName", jdbcType=JdbcType.VARCHAR),
        @Result(column="price_official", property="priceOfficial", jdbcType=JdbcType.DECIMAL),
        @Result(column="price_gun", property="priceGun", jdbcType=JdbcType.DECIMAL),
        @Result(column="price_vip", property="priceVip", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsGasOilPriceWeek selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsGasOilPriceWeekSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsGasOilPriceWeek record, @Param("example") BsGasOilPriceWeekExample example);

    @UpdateProvider(type=BsGasOilPriceWeekSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsGasOilPriceWeek record, @Param("example") BsGasOilPriceWeekExample example);

    @UpdateProvider(type=BsGasOilPriceWeekSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsGasOilPriceWeek record);

    @Update({
        "update bs_gas_oil_price_week",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "weeks = #{weeks,jdbcType=INTEGER},",
          "oil_type = #{oilType,jdbcType=INTEGER},",
          "oil_type_name = #{oilTypeName,jdbcType=VARCHAR},",
          "oil_no = #{oilNo,jdbcType=VARCHAR},",
          "oil_no_name = #{oilNoName,jdbcType=VARCHAR},",
          "price_official = #{priceOfficial,jdbcType=DECIMAL},",
          "price_gun = #{priceGun,jdbcType=DECIMAL},",
          "price_vip = #{priceVip,jdbcType=DECIMAL},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsGasOilPriceWeek record);
}