package com.hfkj.dao;

import com.hfkj.entity.BsGasOrderReceipt;
import com.hfkj.entity.BsGasOrderReceiptExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsGasOrderReceiptMapper extends BsGasOrderReceiptMapperExt {
    @SelectProvider(type=BsGasOrderReceiptSqlProvider.class, method="countByExample")
    long countByExample(BsGasOrderReceiptExample example);

    @DeleteProvider(type=BsGasOrderReceiptSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsGasOrderReceiptExample example);

    @Delete({
        "delete from bs_gas_order_receipt",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_gas_order_receipt (apply_no, user_receipt_id, ",
        "company_name, tax_no, ",
        "contacts_phone, email, ",
        "agent_id, agent_name, ",
        "agent_staff_id, agent_staff_name, ",
        "mer_no, mer_name, ",
        "order_no, order_child_no, ",
        "oil_no, amount, `status`, ",
        "fail_remark, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{applyNo,jdbcType=VARCHAR}, #{userReceiptId,jdbcType=BIGINT}, ",
        "#{companyName,jdbcType=VARCHAR}, #{taxNo,jdbcType=VARCHAR}, ",
        "#{contactsPhone,jdbcType=VARCHAR}, #{email,jdbcType=VARCHAR}, ",
        "#{agentId,jdbcType=BIGINT}, #{agentName,jdbcType=VARCHAR}, ",
        "#{agentStaffId,jdbcType=BIGINT}, #{agentStaffName,jdbcType=VARCHAR}, ",
        "#{merNo,jdbcType=VARCHAR}, #{merName,jdbcType=VARCHAR}, ",
        "#{orderNo,jdbcType=VARCHAR}, #{orderChildNo,jdbcType=VARCHAR}, ",
        "#{oilNo,jdbcType=VARCHAR}, #{amount,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{failRemark,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsGasOrderReceipt record);

    @InsertProvider(type=BsGasOrderReceiptSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsGasOrderReceipt record);

    @SelectProvider(type=BsGasOrderReceiptSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="apply_no", property="applyNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_receipt_id", property="userReceiptId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_name", property="companyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="tax_no", property="taxNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_phone", property="contactsPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="email", property="email", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_staff_id", property="agentStaffId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_staff_name", property="agentStaffName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_child_no", property="orderChildNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="fail_remark", property="failRemark", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsGasOrderReceipt> selectByExample(BsGasOrderReceiptExample example);

    @Select({
        "select",
        "id, apply_no, user_receipt_id, company_name, tax_no, contacts_phone, email, ",
        "agent_id, agent_name, agent_staff_id, agent_staff_name, mer_no, mer_name, order_no, ",
        "order_child_no, oil_no, amount, `status`, fail_remark, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_gas_order_receipt",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="apply_no", property="applyNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_receipt_id", property="userReceiptId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_name", property="companyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="tax_no", property="taxNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_phone", property="contactsPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="email", property="email", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_staff_id", property="agentStaffId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_staff_name", property="agentStaffName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_child_no", property="orderChildNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="fail_remark", property="failRemark", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsGasOrderReceipt selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsGasOrderReceiptSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsGasOrderReceipt record, @Param("example") BsGasOrderReceiptExample example);

    @UpdateProvider(type=BsGasOrderReceiptSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsGasOrderReceipt record, @Param("example") BsGasOrderReceiptExample example);

    @UpdateProvider(type=BsGasOrderReceiptSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsGasOrderReceipt record);

    @Update({
        "update bs_gas_order_receipt",
        "set apply_no = #{applyNo,jdbcType=VARCHAR},",
          "user_receipt_id = #{userReceiptId,jdbcType=BIGINT},",
          "company_name = #{companyName,jdbcType=VARCHAR},",
          "tax_no = #{taxNo,jdbcType=VARCHAR},",
          "contacts_phone = #{contactsPhone,jdbcType=VARCHAR},",
          "email = #{email,jdbcType=VARCHAR},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "agent_name = #{agentName,jdbcType=VARCHAR},",
          "agent_staff_id = #{agentStaffId,jdbcType=BIGINT},",
          "agent_staff_name = #{agentStaffName,jdbcType=VARCHAR},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "order_child_no = #{orderChildNo,jdbcType=VARCHAR},",
          "oil_no = #{oilNo,jdbcType=VARCHAR},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "fail_remark = #{failRemark,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsGasOrderReceipt record);
}