package com.hfkj.dao;

import com.hfkj.entity.BsMerchantChainBrand;
import com.hfkj.entity.BsMerchantChainBrandExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerchantChainBrandMapper extends BsMerchantChainBrandMapperExt {
    @SelectProvider(type=BsMerchantChainBrandSqlProvider.class, method="countByExample")
    long countByExample(BsMerchantChainBrandExample example);

    @DeleteProvider(type=BsMerchantChainBrandSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerchantChainBrandExample example);

    @Delete({
        "delete from bs_merchant_chain_brand",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_merchant_chain_brand (`name`, contacts_name, ",
        "contacts_telephone, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{name,jdbcType=VARCHAR}, #{contactsName,jdbcType=VARCHAR}, ",
        "#{contactsTelephone,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerchantChainBrand record);

    @InsertProvider(type=BsMerchantChainBrandSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerchantChainBrand record);

    @SelectProvider(type=BsMerchantChainBrandSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_name", property="contactsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_telephone", property="contactsTelephone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerchantChainBrand> selectByExample(BsMerchantChainBrandExample example);

    @Select({
        "select",
        "id, `name`, contacts_name, contacts_telephone, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_merchant_chain_brand",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_name", property="contactsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="contacts_telephone", property="contactsTelephone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerchantChainBrand selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerchantChainBrandSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerchantChainBrand record, @Param("example") BsMerchantChainBrandExample example);

    @UpdateProvider(type=BsMerchantChainBrandSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerchantChainBrand record, @Param("example") BsMerchantChainBrandExample example);

    @UpdateProvider(type=BsMerchantChainBrandSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerchantChainBrand record);

    @Update({
        "update bs_merchant_chain_brand",
        "set `name` = #{name,jdbcType=VARCHAR},",
          "contacts_name = #{contactsName,jdbcType=VARCHAR},",
          "contacts_telephone = #{contactsTelephone,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerchantChainBrand record);
}