package com.hfkj.model;

import com.hfkj.entity.*;
import lombok.Data;

import java.util.List;

/**
 * 系统用户登录session对象
 */
@Data
public class SecUserSessionObject {

    /**
     * 登录账户
     */
    private SecUser account;

    /**
     * 角色信息
     */
    private SecRole role;

    /**
     * 商户
     */
    private BsMerchant merchant;

    /**
     * 代理商
     */
    private BsAgent agent;

    /**
     * 菜单
     */
    private List<MenuTreeModel> menuTree;

    /**
     * 按钮
     */
    private List<SecMenu> button;

    public SecUserSessionObject(SecUser account, SecRole role, BsMerchant merchant, BsAgent agent, List<MenuTreeModel> menuTree, List<SecMenu> button){
        this.account = account;
        this.role = role;
        this.merchant = merchant;
        this.agent = agent;
        this.menuTree = menuTree;
        this.button = button;
    }

}
