package com.hfkj.openapi.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @className: RequestQueryGasListModel
 * @author: HuRui
 * @date: 2024/9/18
 **/
@Data
public class RequestQueryGasListModel {

    /**
     * appid
     */
    @NotBlank(message = "appId必填项")
    private String appId;

    /**
     * 分页页数
     */
    @NotNull(message =  "页数必填项")
    private Integer pageNum;

    /**
     * 每页数量
     */
    @Range(min = 1, max = 100,message = "数量必须设置在1至100之内")
    @NotNull(message =  "每页数量必填项")
    private Integer pageSize;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
